PyCursor (Jython API documentation)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.ziclix.python.sql
Class PyCursor

    java.lang.Object
      |
      +--org.python.core.PyObject
            |
            +--com.ziclix.python.sql.PyCursor

All Implemented Interfaces:
  ClassDictInit, java.io.Serializable

Direct Known Subclasses:
  PyExtendedCursor

public class PyCursor
extends PyObject
implements ClassDictInit

These objects represent a database cursor, which is used to manage the context of a fetch operation.

Version:
  $Revision: 1.12 $
Author:
  brian zimmer
, last revised by $Author: bzimmer $
See Also:
  Serialized Form

Field Summary
`static PyClass` | `__class__` Field __class__

Method Summary
`void` | `__del__()` Delete the cursor.
`PyObject` | `__findattr__(java.lang.String name)` Gets the value of the attribute name.
`void` | `__setattr__(java.lang.String name, PyObject value)` Sets the attribute name to value.
`void` | `callproc(PyObject name, PyObject params, PyObject bindings, PyObject maxRows)` This method is optional since not all databases provide stored procedures.
`static void` | `classDictInit(PyObject dict)` Initializes the object's namespace.
`void` | `close()` Close the cursor now (rather than whenever __del__ is called).
`void` | `execute(java.lang.String sqlString, PyObject params, PyObject bindings, PyObject maxRows)` Prepare and execute a database operation (query or command).
`void` | `executemany(java.lang.String sqlString, PyObject params, PyObject bindings, PyObject maxRows)` Prepare a database operation (query or command) and then execute it against all parameter sequences or mappings found in the sequence seq_of_parameters.
`PyObject` | `fetchall()` Fetch all (remaining) rows of a query result, returning them as a sequence of sequences (e.g. a list of tuples).
`PyObject` | `fetchmany(int size)` Fetch the next set of rows of a query result, returning a sequence of sequences (e.g. a list of tuples).
`PyObject` | `fetchone()` Fetch the next row of a query result set, returning a single sequence, or None when no more data is available.
`DataHandler` | `getDataHandler()` Return the currently bound DataHandler.
`PyObject` | `nextset()` Move the result pointer to the next set if available.
`java.lang.String` | `toString()` String representation of the object.

Methods inherited from class org.python.core.PyObject
`__abs__, __add__, __and__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __cmp__, __coerce__, __coerce_ex__, __complex__, __contains__, __delattr__, __delattr__, __delitem__, __delitem__, __delslice__, __delslice__, __dir__, __div__, __divmod__, __eq__, __findattr__, __finditem__, __finditem__, __finditem__, __float__, __ge__, __getattr__, __getattr__, __getitem__, __getitem__, __getslice__, __getslice__, __gt__, __hash__, __hex__, __iadd__, __iand__, __idiv__, __idivmod__, __ilshift__, __imod__, __imul__, __int__, __invert__, __ior__, __ipow__, __irshift__, __isub__, __ixor__, __le__, __len__, __long__, __lshift__, __lt__, __mod__, __mul__, __ne__, __neg__, __nonzero__, __not__, __oct__, __or__, __pos__, __pow__, __pow__, __radd__, __rand__, __rdiv__, __rdivmod__, __repr__, __rlshift__, __rmod__, __rmul__, __ror__, __rpow__, __rrshift__, __rshift__, __rsub__, __rxor__, __setattr__, __setitem__, __setitem__, __setitem__, __setslice__, __setslice__, __str__, __sub__, __tojava__, __xor__, _add, _and, _callextra, _cmp, _div, _divmod, _dodel, _doget, _doget, _doset, _eq, _ge, _gt, _in, _is, _isnot, _jcall, _jcallexc, _jthrow, _le, _lshift, _lt, _mod, _mul, _ne, _notin, _or, _pow, _rshift, _sub, _xor, equals, hashCode, invoke, invoke, invoke, invoke, invoke, isCallable, isMappingType, isNumberType, isSequenceType, safeRepr`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### __class__

    public static PyClass __class__

  Field __class__

Method Detail

### toString

    public java.lang.String toString()

  String representation of the object.

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    a string representation of the object.

### __setattr__

    public void __setattr__(java.lang.String name,
                            PyObject value)

  Sets the attribute name to value.

  Overrides:
    `__setattr__` in class `PyObject`
  Parameters:
    `name` -
    `value` -
  See Also:
    `PyObject.__setattr__(PyString, PyObject)`

### __findattr__

    public PyObject __findattr__(java.lang.String name)

  Gets the value of the attribute name.

  Overrides:
    `__findattr__` in class `PyObject`
  Parameters:
    `name` -
  Returns:
    the attribute for the given name
  See Also:
    `PyObject.__findattr__(PyString)`

### classDictInit

    public static void classDictInit(PyObject dict)

  Initializes the object's namespace.

  Parameters:
    `dict` -

### __del__

    public void __del__()

  Delete the cursor.

### close

    public void close()

  Close the cursor now (rather than whenever __del__ is called). The cursor will be unusable from this point forward; an Error (or subclass) exception will be raised if any operation is attempted with the cursor.

### getDataHandler

    public DataHandler getDataHandler()

  Return the currently bound DataHandler.

### callproc

    public void callproc(PyObject name,
                         PyObject params,
                         PyObject bindings,
                         PyObject maxRows)

  This method is optional since not all databases provide stored procedures. Call a stored database procedure with the given name. The sequence of parameters must contain one entry for each argument that the procedure expects. The result of the call is returned as modified copy of the input sequence. Input parameters are left untouched, output and input/output parameters replaced with possibly new values. The procedure may also provide a result set as output. This must then be made available through the standard fetchXXX() methods.

### executemany

    public void executemany(java.lang.String sqlString,
                            PyObject params,
                            PyObject bindings,
                            PyObject maxRows)

  Prepare a database operation (query or command) and then execute it against all parameter sequences or mappings found in the sequence seq_of_parameters. Modules are free to implement this method using multiple calls to the execute() method or by using array operations to have the database process the sequence as a whole in one call. The same comments as for execute() also apply accordingly to this method. Return values are not defined.

### execute

    public void execute(java.lang.String sqlString,
                        PyObject params,
                        PyObject bindings,
                        PyObject maxRows)

  Prepare and execute a database operation (query or command). Parameters may be provided as sequence or mapping and will be bound to variables in the operation. Variables are specified in a database-specific notation (see the module's paramstyle attribute for details). A reference to the operation will be retained by the cursor. If the same operation object is passed in again, then the cursor can optimize its behavior. This is most effective for algorithms where the same operation is used, but different parameters are bound to it (many times). For maximum efficiency when reusing an operation, it is best to use the setinputsizes() method to specify the parameter types and sizes ahead of time. It is legal for a parameter to not match the predefined information; the implementation should compensate, possibly with a loss of efficiency. The parameters may also be specified as list of tuples to e.g. insert multiple rows in a single operation, but this kind of usage is deprecated: executemany() should be used instead. Return values are not defined.

  Parameters:
    `sqlString` - sql string
    `params` - params for a prepared statement
    `bindings` - dictionary of (param index : SQLType binding)
    `maxRows` - integer value of max rows

### fetchone

    public PyObject fetchone()

  Fetch the next row of a query result set, returning a single sequence, or None when no more data is available. An Error (or subclass) exception is raised if the previous call to executeXXX() did not produce any result set or no call was issued yet.

  Returns:
    a single sequence from the result set, or None when no more data is available

### fetchall

    public PyObject fetchall()

  Fetch all (remaining) rows of a query result, returning them as a sequence of sequences (e.g. a list of tuples). Note that the cursor's arraysize attribute can affect the performance of this operation. An Error (or subclass) exception is raised if the previous call to executeXXX() did not produce any result set or no call was issued yet.

  Returns:
    a sequence of sequences from the result set, or None when no more data is available

### fetchmany

    public PyObject fetchmany(int size)

  Fetch the next set of rows of a query result, returning a sequence of sequences (e.g. a list of tuples). An empty sequence is returned when no more rows are available. The number of rows to fetch per call is specified by the parameter. If it is not given, the cursor's arraysize determines the number of rows to be fetched. The method should try to fetch as many rows as indicated by the size parameter. If this is not possible due to the specified number of rows not being available, fewer rows may be returned. An Error (or subclass) exception is raised if the previous call to executeXXX() did not produce any result set or no call was issued yet. Note there are performance considerations involved with the size parameter. For optimal performance, it is usually best to use the arraysize attribute. If the size parameter is used, then it is best for it to retain the same value from one fetchmany() call to the next.

  Returns:
    a sequence of sequences from the result set, or None when no more data is available

### nextset

    public PyObject nextset()

  Move the result pointer to the next set if available.

  Returns:
    true if more sets exist, else None

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Jython homepage